<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>MapUtil xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../apidocs/org/eclipse/papyrus/designer/transformation/base/utils/MapUtil.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.transformation.base.utils;
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.ecore.EObject;
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.profile.Transformation.DerivedElement;
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Element;
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Interface;
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.NamedElement;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Namespace;
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageMerge;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.PackageableElement;
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Stereotype;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateSignature;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.TemplateableElement;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Type;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/MapUtil.html">MapUtil</a> {
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <em class="jxr_javadoccomment">	 * Get or create a derived type for a given element</em>
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <em class="jxr_javadoccomment">	 *            An element for which the derived element should be created. Used to determine the model in which</em>
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <em class="jxr_javadoccomment">	 *            to create the derived element</em>
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <em class="jxr_javadoccomment">	 * @param prefix</em>
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <em class="jxr_javadoccomment">	 *            prefix string</em>
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <em class="jxr_javadoccomment">	 * @param type</em>
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <em class="jxr_javadoccomment">	 *            type name</em>
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <em class="jxr_javadoccomment">	 * @param createKind</em>
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <em class="jxr_javadoccomment">	 *            if non NONE, create either an interfaces or a class, if it does not exist yet</em>
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  	<strong class="jxr_keyword">public</strong> enum <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/MapUtil.html">ECreateKind</a> {
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  		CLASS, INTERFACE, NONE
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  	}
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  <em class="jxr_javadoccomment">	 * </em>
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 * @param format a format string for the name of the new type. This name is obtained by call the String.format function and</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 * 	passing the original type name as parameter. E.g. the call can use a fixed name, if the format string does not contain</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  <em class="jxr_javadoccomment">	 *  a %s directive, a %s at the end of the format string enables a fixed prefix and so on.</em>
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  <em class="jxr_javadoccomment">	 * @param type</em>
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  <em class="jxr_javadoccomment">	 * @param createKind</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Type getOrCreateDerivedType(Element element, String format, Type type, <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/base/utils/MapUtil.html">ECreateKind</a> createKind) {
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  		String typeName = String.format(format, type.getName());
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  	
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  		<em class="jxr_comment">// create derived element in "derivedInterface" package within the model owning</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  		<em class="jxr_comment">// the port (which must be an FCM model, since the port carries the FCM stereotype)</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  		Package baseModelOfPort = getTop(element);
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		<em class="jxr_comment">// handle specific case of type within template. Place derived type into same template.</em>
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		Package derivedTypes = getAndCreate(baseModelOfPort, DERIVED_TYPES, createKind != ECreateKind.NONE);
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		<strong class="jxr_keyword">if</strong> (derivedTypes != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  			Package owner = getAndCreate(derivedTypes, type.allNamespaces(), createKind != ECreateKind.NONE);
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  			Interface intf = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  	
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  			PackageableElement pe = owner.getPackagedElement(typeName);
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  			<strong class="jxr_keyword">if</strong> (pe instanceof Type) {
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  				<em class="jxr_comment">// type already exists</em>
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  				<strong class="jxr_keyword">return</strong> (Type) pe;
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (createKind == ECreateKind.INTERFACE) {
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  				<em class="jxr_comment">// System.out.println ("Derived port types: create new interface " + typeName + " in package " + owner.getQualifiedName ());</em>
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				intf = owner.createOwnedInterface(typeName);
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  	
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				<em class="jxr_comment">// System.out.println ("Derived port types: Apply derived stereotype annotation to interface: " + intf.getQualifiedName());</em>
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  				DerivedElement de = applyDE(intf);
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  				<strong class="jxr_keyword">if</strong> (de != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  					<em class="jxr_comment">// de may be null, if FCM is not properly applied</em>
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					de.setSource(type);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  				<strong class="jxr_keyword">return</strong> intf;
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  			} <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (createKind == ECreateKind.CLASS) {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  				<em class="jxr_comment">// System.out.println ("Derived port types: create new interface " + typeName + " in package " + owner.getQualifiedName ());</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  				Class newType = owner.createOwnedClass(typeName, false);
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  	
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  				<em class="jxr_comment">// System.out.println ("Derived port types: Apply derived stereotype annotation to interface: " + intf.getQualifiedName());</em>
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  				DerivedElement de = applyDE(newType);
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  				<strong class="jxr_keyword">if</strong> (de != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  					<em class="jxr_comment">// de may be null, if FCM is not properly applied</em>
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  					de.setSource(type);
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  				}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  				<strong class="jxr_keyword">return</strong> newType;
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  			}
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  		}
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  	
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  		<em class="jxr_comment">// instead of returning null, return a dummy interface that indicates the user that an element needs updating.</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  		PackageableElement portKinds = baseModelOfPort.getImportedMember(<span class="jxr_string">"PortKinds"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  		<strong class="jxr_keyword">if</strong> (portKinds instanceof Package) {
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  			PackageableElement pe = ((Package) portKinds).getPackagedElement(<span class="jxr_string">"Please update derived elements"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> 			<strong class="jxr_keyword">if</strong> (pe instanceof Interface) {
<a class="jxr_linenumber" name="L101" href="#L101">101</a> 				<em class="jxr_comment">// dummy interface exists</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> 				<strong class="jxr_keyword">return</strong> (Interface) pe;
<a class="jxr_linenumber" name="L103" href="#L103">103</a> 			}
<a class="jxr_linenumber" name="L104" href="#L104">104</a> 		}
<a class="jxr_linenumber" name="L105" href="#L105">105</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L106" href="#L106">106</a> 	}
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L109" href="#L109">109</a> <em class="jxr_javadoccomment">	 * Get the template signature of a templateable element (typically a package). The class must</em>
<a class="jxr_linenumber" name="L110" href="#L110">110</a> <em class="jxr_javadoccomment">	 * (1) either own the signature</em>
<a class="jxr_linenumber" name="L111" href="#L111">111</a> <em class="jxr_javadoccomment">	 * (2) or merge with a package which owns the signature.</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> <em class="jxr_javadoccomment">	 * Qompass enables the "extension" of existing packages via the package merge mechanism</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L114" href="#L114">114</a> <em class="jxr_javadoccomment">	 * @param template</em>
<a class="jxr_linenumber" name="L115" href="#L115">115</a> <em class="jxr_javadoccomment">	 *            The potential template</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> <em class="jxr_javadoccomment">	 * @return the signature or null, if none can be found.</em>
<a class="jxr_linenumber" name="L117" href="#L117">117</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> TemplateSignature getSignature(TemplateableElement template) {
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		<strong class="jxr_keyword">for</strong> (Element element : template.getOwnedElements()) {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 			<strong class="jxr_keyword">if</strong> (element instanceof TemplateSignature) {
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 				<strong class="jxr_keyword">return</strong> (TemplateSignature) element;
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			}
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 		}
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 	
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		<em class="jxr_comment">// enable multiple package templates sharing the same signature.</em>
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 		<strong class="jxr_keyword">if</strong> (template instanceof Package) {
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 			Package pkg = (Package) template;
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 			<strong class="jxr_keyword">for</strong> (PackageMerge pkgImport : pkg.getPackageMerges()) {
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 				Package importedPkg = pkgImport.getMergedPackage();
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 				<strong class="jxr_keyword">return</strong> getSignature(importedPkg);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 			}
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		}
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 	}
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L137" href="#L137">137</a> <em class="jxr_javadoccomment">	 * Return the top-level owner of an element. This function returns the same value</em>
<a class="jxr_linenumber" name="L138" href="#L138">138</a> <em class="jxr_javadoccomment">	 * as getModel, if the top-level element is a model and not contained in a template</em>
<a class="jxr_linenumber" name="L139" href="#L139">139</a> <em class="jxr_javadoccomment">	 * While this is the case for models, model libraries have a top-level package (not</em>
<a class="jxr_linenumber" name="L140" href="#L140">140</a> <em class="jxr_javadoccomment">	 * a model). In this case, getTop returns the top-level package whereas getModel</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> <em class="jxr_javadoccomment">	 * would return null.</em>
<a class="jxr_linenumber" name="L142" href="#L142">142</a> <em class="jxr_javadoccomment">	 * In case of a package owning a signature, it returns this package instead of the</em>
<a class="jxr_linenumber" name="L143" href="#L143">143</a> <em class="jxr_javadoccomment">	 * top level package. The reason is that the derived types might reference elements</em>
<a class="jxr_linenumber" name="L144" href="#L144">144</a> <em class="jxr_javadoccomment">	 * of the template signature which would be undefined outside.</em>
<a class="jxr_linenumber" name="L145" href="#L145">145</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L146" href="#L146">146</a> <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_javadoccomment">	 *            An element of which we want to query</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_javadoccomment">	 * @return the top-level owning package</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package getTop(Element element) {
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 		<strong class="jxr_keyword">while</strong> (element != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L152" href="#L152">152</a> 			Element owner = element.getOwner();
<a class="jxr_linenumber" name="L153" href="#L153">153</a> 			<strong class="jxr_keyword">if</strong> (owner == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L154" href="#L154">154</a> 				<strong class="jxr_keyword">if</strong> (element instanceof Package) {
<a class="jxr_linenumber" name="L155" href="#L155">155</a> 					<strong class="jxr_keyword">return</strong> (Package) element;
<a class="jxr_linenumber" name="L156" href="#L156">156</a> 				}
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 			}
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 			<strong class="jxr_keyword">if</strong> ((element instanceof Package) &amp;&amp; (getSignature((Package) element) != <strong class="jxr_keyword">null</strong>)) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 				<strong class="jxr_keyword">return</strong> (Package) element;
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 			}
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 			element = owner;
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 		}
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 	}
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 	<strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">final</strong> String DERIVED_TYPES = <span class="jxr_string">"derivedTypes"</span>; <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L169" href="#L169">169</a> <em class="jxr_javadoccomment">	 * Apply the derived element stereotype to a model element</em>
<a class="jxr_linenumber" name="L170" href="#L170">170</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L171" href="#L171">171</a> <em class="jxr_javadoccomment">	 * @param element</em>
<a class="jxr_linenumber" name="L172" href="#L172">172</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> <a href="../../../../../../../org/eclipse/papyrus/designer/transformation/profile/Transformation/DerivedElement.html">DerivedElement</a> applyDE(Element element) {
<a class="jxr_linenumber" name="L175" href="#L175">175</a> 		Stereotype stereotype = element.getApplicableStereotype(<span class="jxr_string">"FCM::DerivedElement"</span>); <em class="jxr_comment">//$NON-NLS-1$</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> 		<strong class="jxr_keyword">if</strong> (stereotype != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 			EObject alreadyApplied = element.getStereotypeApplication(stereotype);
<a class="jxr_linenumber" name="L178" href="#L178">178</a> 			<strong class="jxr_keyword">if</strong> (alreadyApplied instanceof DerivedElement) {
<a class="jxr_linenumber" name="L179" href="#L179">179</a> 				<strong class="jxr_keyword">return</strong> (DerivedElement) alreadyApplied;
<a class="jxr_linenumber" name="L180" href="#L180">180</a> 			}
<a class="jxr_linenumber" name="L181" href="#L181">181</a> 			alreadyApplied = element.applyStereotype(stereotype);
<a class="jxr_linenumber" name="L182" href="#L182">182</a> 			<strong class="jxr_keyword">if</strong> (alreadyApplied instanceof DerivedElement) {
<a class="jxr_linenumber" name="L183" href="#L183">183</a> 				<strong class="jxr_keyword">return</strong> (DerivedElement) alreadyApplied;
<a class="jxr_linenumber" name="L184" href="#L184">184</a> 			}
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 		}
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 		<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 	}
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L190" href="#L190">190</a> <em class="jxr_javadoccomment">	 * This function returns a Package reference that corresponds to a qualified name.</em>
<a class="jxr_linenumber" name="L191" href="#L191">191</a> <em class="jxr_javadoccomment">	 * Packages are created, if not existing yet - the function is thus a bit similar to</em>
<a class="jxr_linenumber" name="L192" href="#L192">192</a> <em class="jxr_javadoccomment">	 * the unix "mkdir -p" command. Note that the main model within the list of name-spaces is</em>
<a class="jxr_linenumber" name="L193" href="#L193">193</a> <em class="jxr_javadoccomment">	 * ignored, in order to avoid that a sub-package within a model starts with the name</em>
<a class="jxr_linenumber" name="L194" href="#L194">194</a> <em class="jxr_javadoccomment">	 * of the model.</em>
<a class="jxr_linenumber" name="L195" href="#L195">195</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L196" href="#L196">196</a> <em class="jxr_javadoccomment">	 * @param model</em>
<a class="jxr_linenumber" name="L197" href="#L197">197</a> <em class="jxr_javadoccomment">	 *            a model</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * @param list</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 *            a list of namespace elements (as can be obtained via allNamespaces),</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 *            the top-level element is the last within the list.</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * @param skipTop</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 *            if true, skip top level namespace element</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> <em class="jxr_javadoccomment">	 * @return</em>
<a class="jxr_linenumber" name="L204" href="#L204">204</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package getAndCreate(Package root, EList&lt;Namespace&gt; list, <strong class="jxr_keyword">boolean</strong> createOnDemand) {
<a class="jxr_linenumber" name="L206" href="#L206">206</a> 		<strong class="jxr_keyword">for</strong> (<strong class="jxr_keyword">int</strong> i = list.size() - 1; i &gt;= 0; i--) {
<a class="jxr_linenumber" name="L207" href="#L207">207</a> 			Namespace ns = list.get(i);
<a class="jxr_linenumber" name="L208" href="#L208">208</a> 	
<a class="jxr_linenumber" name="L209" href="#L209">209</a> 			NamedElement pkg = root.getOwnedMember(ns.getName());
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 			<strong class="jxr_keyword">if</strong> ((pkg == <strong class="jxr_keyword">null</strong>) &amp;&amp; createOnDemand) {
<a class="jxr_linenumber" name="L211" href="#L211">211</a> 				<em class="jxr_comment">// package does not exist =&gt; create it.</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> 				pkg = root.createNestedPackage(ns.getName());
<a class="jxr_linenumber" name="L213" href="#L213">213</a> 				<em class="jxr_comment">// copy stereotype to create package</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> 			}
<a class="jxr_linenumber" name="L215" href="#L215">215</a> 			<strong class="jxr_keyword">if</strong> (!(pkg instanceof Package)) {
<a class="jxr_linenumber" name="L216" href="#L216">216</a> 				<strong class="jxr_keyword">break</strong>;
<a class="jxr_linenumber" name="L217" href="#L217">217</a> 			}
<a class="jxr_linenumber" name="L218" href="#L218">218</a> 			root = (Package) pkg;
<a class="jxr_linenumber" name="L219" href="#L219">219</a> 		}
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		<strong class="jxr_keyword">return</strong> root;
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 	}
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L224" href="#L224">224</a> <em class="jxr_javadoccomment">	 * Get or create a package within another package (often the root of a model), i.e. return</em>
<a class="jxr_linenumber" name="L225" href="#L225">225</a> <em class="jxr_javadoccomment">	 * a package with the passed name, if it exists or create a new one of this name</em>
<a class="jxr_linenumber" name="L226" href="#L226">226</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L227" href="#L227">227</a> <em class="jxr_javadoccomment">	 * @param root</em>
<a class="jxr_linenumber" name="L228" href="#L228">228</a> <em class="jxr_javadoccomment">	 *            a package potentially owning a certain element</em>
<a class="jxr_linenumber" name="L229" href="#L229">229</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L230" href="#L230">230</a> <em class="jxr_javadoccomment">	 *            the name of a package that should be be returned.</em>
<a class="jxr_linenumber" name="L231" href="#L231">231</a> <em class="jxr_javadoccomment">	 * @return a package</em>
<a class="jxr_linenumber" name="L232" href="#L232">232</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">static</strong> Package getAndCreate(Package root, String name, <strong class="jxr_keyword">boolean</strong> createOnDemand) {
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 		NamedElement pkg = root.getOwnedMember(name);
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 		<strong class="jxr_keyword">if</strong> ((pkg == <strong class="jxr_keyword">null</strong>) &amp;&amp; createOnDemand) {
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 			pkg = root.createNestedPackage(name);
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 		}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 		<strong class="jxr_keyword">return</strong> (Package) pkg;
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 	}
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 
<a class="jxr_linenumber" name="L241" href="#L241">241</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
